import * as VScript from "vscript";
import * as VAPI from "./index.js";
export declare const lift: {
    readonly All: (_raw: VScript.DataViews.Subtree<VScript.VSocket>) => VAPI.ClosXBar.All;
    readonly Generator: (_raw: VScript.DataViews.Subtree<VScript.VSocket>) => VAPI.ClosXBar.Generator;
};
export declare const lower: {
    readonly All: (_x: All) => string;
    readonly Generator: (_x: Generator) => string;
};
export declare class All implements VScript.Referenceable<"ClosXBar::Data::All"> {
    readonly raw: VScript.DataViews.Subtree<VScript.VSocket>;
    readonly type_identifier: "ClosXBar::Data::All";
    constructor(raw: VScript.DataViews.Subtree<VScript.VSocket>);
    get start_generator(): VScript.StronglyTypedTable<VScript.VSocket, "ClosXBar::Data::Generator", VAPI.ClosXBar.Generator>;
}
export declare class Generator implements VScript.Referenceable<"ClosXBar::Data::Generator"> {
    readonly raw: VScript.DataViews.Subtree<VScript.VSocket>;
    readonly type_identifier: "ClosXBar::Data::Generator";
    constructor(raw: VScript.DataViews.Subtree<VScript.VSocket>);
    get used_config(): VScript.rKeyword<VScript.VSocket, null | number, null | VAPI.Primitives.Unsigned32, VAPI.ClosXBar.Generator>;
    /**
      time to write into the hardware. At this pointer the hardware gets
      informed to perform the switch
    */
    get write_hw(): VScript.rKeyword<VScript.VSocket, null | number, null | VScript.Duration, VAPI.ClosXBar.Generator>;
    /**
      switching time
    */
    get calculated_sw_time(): VScript.rKeyword<VScript.VSocket, null | number, null | VScript.Duration, VAPI.ClosXBar.Generator>;
    /**
      switching time
    */
    get interrupt_sw_time(): VScript.rKeyword<VScript.VSocket, null | number, null | VScript.Duration, VAPI.ClosXBar.Generator>;
    /**
      difference between calculated and interrupt time
    */
    get delta_calc_irq(): VScript.rKeyword<VScript.VSocket, null | number, null | VScript.Duration, VAPI.ClosXBar.Generator>;
    /**
      difference between write hardware and interrupt time
    */
    get delta_write_hw_irq(): VScript.rKeyword<VScript.VSocket, null | number, null | VScript.Duration, VAPI.ClosXBar.Generator>;
}
